#ifndef	MAZE_H
#define	MAZE_H	1

typedef	unsigned char	uchar_t;

/*	Maximum size of maze array.	*/
#define		X_MAXIMUM	250
#define		Y_MAXIMUM	250

/*	Doors and directions tried.	*/
#define		UP				0x01
#define		RIGHT			0x02
#define		DOWN			0x04
#define		LEFT			0x08
#define		GO_UP			0x10
#define		GO_RIGHT		0x20
#define		GO_DOWN			0x40
#define		GO_LEFT			0x80
#define		TRY_ALL			(GO_UP | GO_RIGHT | GO_DOWN | GO_LEFT)
#define		ALL				(UP    | RIGHT    | DOWN    | LEFT   )

@interface		Maze	:	Object
{
	int			xMaximum;
	int			yMaximum;
	int			xCount;
	int			yCount;
	int			offset;
	int			unitLength;
	uchar_t		*breadCrumbs;
	uchar_t		maze[ X_MAXIMUM ][ Y_MAXIMUM ];
}

- initWithXDimension: (int) inXCount
		  YDimension: (int) inYCount ;

- drawLineXStart: (int) x
		  YStart: (int) y
		    XEnd: (int) xEnd
		    YEnd: (int) yEnd ;

- drawSolutionLineXStart: (int) xPrevious
				  YStart: (int) yPrevious
					XEnd: (int) x
					YEnd: (int) y ;

- createMazeAtX: (int) x
			AtY: (int) y ;

- createMaze ;

- (int) findSolutionAtX: (int) x
					AtY: (int) y ;

- solveMaze ;

- printMaze ;

- printMazeSolution ;

- beginDocument;

- endDocument;

- beginPage;

- endPage;

@end

#endif
