/******************************************************************************
* Module	:	Postscript Maze Implementation
*
* Author	:	John W. M. Stevens
******************************************************************************/

#include	<stdio.h>
#include	<stdlib.h>
#include	<math.h>
#include	<time.h>

#include	<objc/Object.h>

#include	"PostscriptMaze.h"

@implementation		PostscriptMaze	:	Maze

- init
{
	/*  Initialize data attributes. */
	xMaximum = 540;
	yMaximum = 720;
	xCount   = 30;
	yCount   = 30;
	offset   = 36;

	/*	Initialize the super class.	*/
	[ super init ];

	/*	Return self.	*/
	return self;
}

- initWithXDimension: (int) inXCount
		  YDimension: (int) inYCount
{
	/*  Initialize data attributes. */
	xMaximum = 540;
	yMaximum = 720;
	xCount   = inXCount;
	yCount   = inYCount;
	offset   = 36;

	/*	Initialize the super class.	*/
	[ super init ];

	/*	Return self.	*/
	return self;
}

- drawLineXStart: (int) x
		  YStart: (int) y
		    XEnd: (int) xEnd
		    YEnd: (int) yEnd
{
	printf(
		"%d %d moveto\n"
		"%d %d lineto\n"
		"stroke\n",
		x               * unitLength + offset,
		(yCount - y   ) * unitLength + offset,
		xEnd            * unitLength + offset,
		(yCount - yEnd) * unitLength + offset );

	return self;
}

- drawSolutionLineXStart: (int) xPrevious
				  YStart: (int) yPrevious
					XEnd: (int) x
					YEnd: (int) y
{
	auto	int		center  = unitLength >> 1;

	printf(
		"%d %d moveto\n"
		"%d %d lineto\n"
		"stroke\n",
		x                    * unitLength + offset + center,
		(yCount - y   )      * unitLength + offset - center,
		xPrevious            * unitLength + offset + center,
		(yCount - yPrevious) * unitLength + offset - center );

	return self;
}

- printMazeSolution
{
	/*	Print postscript start up.	*/
	printf(
		"gsave\n"
		"1.000 0.000 0.000 setrgbcolor\n" );

	/*	Print maze solution.	*/
	[ super
		printMazeSolution ];

	/*	Print postscript start up.	*/
	printf(
		"grestore\n" );

	return self;
}

- endPage
{
	[ super endPage ];

	printf(
		"showpage\n" );

	return self;
}

@end
